<app-loading *ngIf="isLoading"></app-loading>

<!-- update  -->
<nz-card class="header-form m-0">
  <div class="action-breadcrumb-float-right">
    <ng-container *ngTemplateOutlet="action"></ng-container>
  </div>
  <!-- 1 thành phân -->
  <div nz-row [nzGutter]="[32, 32]" [formGroup]="proposeUnitForm">

    <div nz-col class="gutter-row" nzLg="6" *ngIf="proposeCategory !== listProposeCategory.GROUP">
    <mb-select
    formControlName="formGroup"
    [mbDataSelects]="dataCommon.formGroupList"
    mbKeyLabel="name"
    mbKeyValue="id"
    mbLabelText="{{ 'development.proposed-unit.table.formGroup' | translate }}"
    mbPlaceholder="{{ 'development.proposed-unit.table.formGroup' | translate }}"
    (mbSelect)="onChangeProposeType($event)"
    [ngModelOptions]="{ standalone: true}"

  >
  </mb-select>

  </div>

  <div nz-col class="gutter-row rowInfoPropose" nzLg="6" *ngIf="proposeCategory === listProposeCategory.GROUP"></div>


  <div nz-col class="gutter-row" nzLg="6" *ngIf="proposeCategory !== listProposeCategory.GROUP">
    <span class="title-section">{{ 'development.proposed-unit.table.proposeCode' | translate }}</span
    ><br />
    <label class="text-label">{{ proposeUnitForm.get('id')?.value }}</label>
  </div>

  <div nz-col class="gutter-row" nzLg="6" *ngIf="proposeDTO?.relationType && proposeDTO?.handleCode && proposeCategory === listProposeCategory.GROUP">
    <span class="title-section">{{ 'development.proposed-unit.table.processingCode' | translate }}</span
      ><br />
      <label class="text-label">{{ proposeUnitForm.get('handleCode')?.value }}</label>
    </div>



  <div nz-col class="gutter-row" nzLg="6">
    <span class="title-section">{{ 'development.proposed-unit.table.statusApprove' | translate }}</span
    ><br />
    <label class="text-label">{{ proposeUnitForm.get('flowStatusName')?.value }}</label>
  </div>

  <div nz-col class="gutter-row" nzLg="6" *ngIf="proposeUnitForm.get('statusPublishName')?.value">
    <span class="title-section">{{ 'development.proposed-unit.table.statusPublish' | translate }}</span
    ><br />
    <label class="text-label">{{ proposeUnitForm.get('statusPublishName')?.value }}</label>
  </div>

  <div
    nz-col
    class="gutter-row"
    nzLg="6"
    *ngIf="screenCode === screenCodeConst.PTNL && proposeDTO?.relationType && proposeCategory === listProposeCategory.GROUP"
  >
    <span class="title-section">{{ 'development.proposed-unit.table.contentsOfthePlan' | translate }}</span
    ><br />
    <label class="text-label">{{ proposeUnitForm.get('optionNote')?.value }}</label>
  </div>

  <div nz-col class="gutter-row" nzLg="6" *ngIf="proposeUnitForm.get('withdrawNote')?.value">
    <span class="title-section">{{ 'development.proposed-unit.table.notesOnProposalWithdrawal' | translate }}</span
    ><br />
    <label class="text-label">{{ proposeUnitForm.get('withdrawNote')?.value }}</label>
  </div>
  </div>
</nz-card>

<app-propose-single
  *ngIf="isSingle"
  #proposeSingle
  [dataCommon]="dataCommon"
  (saveReport)="saveMultiple($event)"
  (submitStatementDecision)="creteStatementDecision($event)"
  [dataForm]="proposeDTO?.proposeDetails[0]"
  [typeAction]="typeAction"
  [checkUnitRequest]="checkUnitRequest"
  [screenCode]="screenCode"
  [flowStatusCode]="flowStatusCode"
  [flowStatusPublishCode]="statusPublishCode"
  [flowStatusCodeDisplay]="flowStatusCodeDisplay"
  [issueLevelName]="issueLevelName"
  (submitReport)="displayButtonElement($event)"
  [checkLogs]="checkWithdrawBtn()"
  [proposeDetailId]="proposeDetailId"
  [proposeCategory]="proposeCategory"
  [proposeId]="proposeId"
  [stateUrl]="stateUrl"
  [listInUnit]="listInUnit"
  [showMinTime]="showMinTime"
  [showMaxTime]="showMaxTime"
  [externalApproveParent]="externalApproveParent"
  [formGroupCreate]="proposeUnitForm.get('formGroup')?.value"
  [proposeDTO]="proposeDTO"
  [proposeDecisionStatement]="proposeDecisionStatement"
></app-propose-single>

<app-propose-multiple
  *ngIf="isMultiple"
  #proposeMultiple
  [dataCommon]="dataCommon"
  [dataForm]="proposeDTO"
  [typeAction]="typeAction"
  [screenCode]="screenCode"
  [proposeCategory]="proposeCategory"
  [proposeDetailId]="proposeDetailId"
  [flowStatusCode]="flowStatusCode"
  [issueLevelName]="issueLevelName"
  [proposeDecisionStatement]="proposeDecisionStatement"
  [proposeId]="proposeId"
  (submitReport)="displayButonHeader($event)"
  (loadProposedUpdate)="ngOnInit()"
  [proposeUnit]="proposeUnitForm.getRawValue()"
  (onLoading)="onLoading($event)"
  [flowStatusCodeDisplay]="flowStatusCodeDisplay"
  (withdraw)="loadPage($event)"
  [withdrawNoteCode]="withdrawNoteCode"
  (saveMultiple)="saveMultiple($event)"
  [reasonsReject]="approveNote"
  [isAcceptPropose]="isAcceptPropose"
></app-propose-multiple>

<ng-template #dateLog let-actionDate  = 'actionDate'>
  <em nz-icon nzType="calendar" nzTheme="outline" class="calendar" *ngIf="actionDate"></em>
  <span class="sentDate">{{ actionDate | date: 'dd/MM/yyyy HH:mm' }}</span>
</ng-template>

<ng-template #action>
  <ng-container
    *ngIf="
      typeAction === screenType.update && screenCode === screenCodeConst.HRDV
    "
  >
    <!-- nếu trạng thái phê duyệt là 1, 3 -->
    <!-- *ngIf="checkLeaderApprove(flowStatusCode)" -->
    <ng-container>
      <!-- cấp ban hành là đơn vị và hình thức là điều động -->
      <ng-container
        *ngIf="(issueLevelName === unitIssueLevel || issueLevelName ===  unitIssueLevelLive) && formRotationType === formRotationTypeConst.DD"
      >
        <!-- ban hành -->
        <mb-button
          mbButtonAvailableStyle="BORDER"
          *ngIf="!stateUrl?.state?.backUrl && (checkIssueDecision() && !proposeDTO?.isHo)"
          mbButtonText="{{ 'development.proposed-unit.button.issueDecision' | translate }}"
          (click)="issueDecision()">
        </mb-button>
        <!-- LDDV k đồng ý -->
        <mb-button
          mbButtonAvailableStyle="BORDER"
          mbButtonSize="LARGE"
          *ngIf="screenCode !== screenCodeConst.HRDV"
          mbButtonText="{{ 'development.proposed-unit.button.reject' | translate }}"
          (click)="reject()">
        </mb-button>
      </ng-container>

      <!-- tất cả các trường hợp còn lại của trạng thái 1, 3 -->
      <!-- *ngIf="
          !(issueLevelName === unitIssueLevel && formRotationType === formRotationTypeConst.DD)
        " -->
      <ng-container>
        <!-- ghi nhận đồng ý -->
        <mb-button
          mbButtonAvailableStyle="BORDER"
          mbButtonSize="LARGE"
          *ngIf="checkRecordApprove()"
          mbButtonText="{{ 'development.proposed-unit.button.sendPropose' | translate }}"
          (click)="acceptPropose()">
        </mb-button>
        <!-- LDDV k đồng ý -->
        <mb-button
          mbButtonAvailableStyle="BORDER"
          mbButtonSize="LARGE"
          *ngIf="displayReport && screenCode !== screenCodeConst.HRDV"
          mbButtonText="{{ 'development.proposed-unit.button.reject' | translate }}"
          (click)="reject()">
        </mb-button>
        <!-- gửi duyệt -->
        <mb-button
          mbButtonAvailableStyle="BORDER"
          mbButtonSize="LARGE"
          *ngIf="checkSendApprove2()"
          mbButtonText="{{ 'development.proposed-unit.button.sendPropose' | translate }}"
          (click)="sendPropose()">
        </mb-button>
      </ng-container>
    </ng-container>
  </ng-container>
  <!-- lưu -->
  <mb-button
      mbButtonAvailableStyle="PRIMARY"
      mbButtonSize="LARGE"
      mbButtonText="{{ 'development.proposed-unit.button.save' | translate }}"
      *ngIf="checkSaveButtonUpdateScreen()"
      (click)="submit()">
  </mb-button>
  <!-- xóa -->
  <mb-button
      mbButtonAvailableStyle="DANGER"
      mbButtonSize="LARGE"
      *ngIf="checkBtnDelete()"
      mbButtonText="{{ 'development.proposed-unit.button.delete' | translate }}"
      (click)="delete($event)">
  </mb-button>

  <!-- nhiều thành phần -->
  <ng-container *ngIf="checkApproveLDDV()">
    <mb-button
      mbButtonAvailableStyle="PRIMARY"
      mbButtonSize="LARGE"
      mbButtonText="{{ 'development.proposed-unit.button.agreeLeader' | translate }}"
      (click)="agreeLeader()">
    </mb-button>

    <mb-button
      mbButtonAvailableStyle="DANGER"
      mbButtonSize="LARGE"
      mbButtonText="{{ 'development.proposed-unit.button.rejectLeader' | translate }}"
      (click)="rejectLeader()"
      *ngIf="flowStatusCode === this.flowCodeConst.CHODUYET2">
    </mb-button>

    <mb-button
      mbButtonAvailableStyle="BORDER"
      mbButtonSize="LARGE"
      mbButtonText="{{ 'development.proposed-unit.button.withDraw' | translate }}"
      (click)="otherIdea()">
    </mb-button>
  </ng-container>

<!--duyệt rút đề xuất-->
  <ng-container *ngIf="checkWithdrawBtn()">
    <mb-button
      mbButtonAvailableStyle="PRIMARY"
      mbButtonSize="LARGE"
      mbButtonText="{{ 'development.proposed-unit.button.agreeLeader' | translate }}"
      (click)="agreeWithdrawProposal(1)">
    </mb-button>

    <mb-button
      mbButtonAvailableStyle="DANGER"
      mbButtonSize="LARGE"
      mbButtonText="{{ 'development.proposed-unit.button.rejectLeader' | translate }}"
      (click)="agreeWithdrawProposal(2)">
    </mb-button>

    <mb-button
      mbButtonAvailableStyle="BORDER"
      mbButtonSize="LARGE"
      mbButtonText="{{ 'development.proposed-unit.button.otherIdea' | translate }}"
      (click)="agreeWithdrawProposal(3)">
    </mb-button>
  </ng-container>

  <ng-container
    *ngIf="
      screenCode === screenCodeConst.PTNL && typeAction !== screenType.detail
    "
  >


    <ng-container *ngIf="typeAction === screenType.update">
      <mb-button
        mbButtonAvailableStyle="BORDER"
        mbButtonSize="LARGE"
        *ngIf="checkHandleButton()"
        mbButtonText="{{ 'development.proposed-unit.button.handle' | translate }}"
        (click)="handle()">
      </mb-button>
    </ng-container>
  </ng-container>
  <mb-button
    mbButtonAvailableStyle="BORDER"
    mbButtonSize="LARGE"
    *ngIf="stateUrl"
    mbButtonText="{{ 'development.proposed-unit.button.back' | translate }}"
    (click)="back()">
  </mb-button>
</ng-template>
